using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;

namespace ContactsPPC
{
	/// <summary>
	/// Description rsume de Details.
	/// </summary>
	public class Details : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu MenuApp;
		private System.Windows.Forms.MenuItem FileMenu;
		private System.Windows.Forms.MenuItem ItemQuitter;
		private int Contact_Id;
		private SqlCeConnection SqlCnx;
		private SqlCeCommand SqlCommand;
		private SqlCeDataReader daReader;
		private System.Windows.Forms.PictureBox pbImage;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbNom;
		private System.Windows.Forms.TextBox tbPrenom;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbAdresse;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbVille;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tbCp;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox tbEmail;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox tbPortable;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox tbTelephone;
		private System.Windows.Forms.MenuItem ActionsMenu;
		private System.Windows.Forms.MenuItem ItemModifier;
		private System.Windows.Forms.Button btImage;
		private System.Windows.Forms.Button btRAZ;
		private System.Windows.Forms.Button btValider;
		private System.Windows.Forms.Button btRetour;
		private System.Windows.Forms.OpenFileDialog ChoixFichier;
		private string sSQL = String.Empty;
	
		public Details(bool bEditTextBox, string ContactNum)
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			// Si on est dans le mode d'dition d'un contact
			if ( bEditTextBox )
			{
				EditContact();
			}

			Contact_Id = Convert.ToInt32(ContactNum);
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.pbImage = new System.Windows.Forms.PictureBox();
			this.MenuApp = new System.Windows.Forms.MainMenu();
			this.FileMenu = new System.Windows.Forms.MenuItem();
			this.ItemQuitter = new System.Windows.Forms.MenuItem();
			this.label1 = new System.Windows.Forms.Label();
			this.tbNom = new System.Windows.Forms.TextBox();
			this.tbPrenom = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tbAdresse = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tbVille = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.tbCp = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.tbEmail = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.tbTelephone = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.tbPortable = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.ActionsMenu = new System.Windows.Forms.MenuItem();
			this.ItemModifier = new System.Windows.Forms.MenuItem();
			this.btImage = new System.Windows.Forms.Button();
			this.btRAZ = new System.Windows.Forms.Button();
			this.btRetour = new System.Windows.Forms.Button();
			this.btValider = new System.Windows.Forms.Button();
			this.ChoixFichier = new System.Windows.Forms.OpenFileDialog();
			// 
			// pbImage
			// 
			this.pbImage.Location = new System.Drawing.Point(170, 8);
			this.pbImage.Size = new System.Drawing.Size(64, 64);
			// 
			// MenuApp
			// 
			this.MenuApp.MenuItems.Add(this.FileMenu);
			this.MenuApp.MenuItems.Add(this.ActionsMenu);
			// 
			// FileMenu
			// 
			this.FileMenu.MenuItems.Add(this.ItemQuitter);
			this.FileMenu.Text = "Fichier";
			// 
			// ItemQuitter
			// 
			this.ItemQuitter.Text = "Quitter";
			this.ItemQuitter.Click += new System.EventHandler(this.ItemQuitter_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(0, 16);
			this.label1.Size = new System.Drawing.Size(32, 20);
			this.label1.Text = "Nom";
			// 
			// tbNom
			// 
			this.tbNom.Enabled = false;
			this.tbNom.Location = new System.Drawing.Point(64, 16);
			this.tbNom.Text = "";
			// 
			// tbPrenom
			// 
			this.tbPrenom.Enabled = false;
			this.tbPrenom.Location = new System.Drawing.Point(64, 48);
			this.tbPrenom.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(0, 48);
			this.label2.Size = new System.Drawing.Size(48, 20);
			this.label2.Text = "Prenom";
			// 
			// tbAdresse
			// 
			this.tbAdresse.Enabled = false;
			this.tbAdresse.Location = new System.Drawing.Point(64, 80);
			this.tbAdresse.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(0, 80);
			this.label3.Size = new System.Drawing.Size(48, 20);
			this.label3.Text = "Adresse";
			// 
			// tbVille
			// 
			this.tbVille.Enabled = false;
			this.tbVille.Location = new System.Drawing.Point(64, 112);
			this.tbVille.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(0, 112);
			this.label4.Size = new System.Drawing.Size(48, 20);
			this.label4.Text = "Ville";
			// 
			// tbCp
			// 
			this.tbCp.Enabled = false;
			this.tbCp.Location = new System.Drawing.Point(64, 144);
			this.tbCp.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(0, 144);
			this.label5.Size = new System.Drawing.Size(48, 20);
			this.label5.Text = "CP";
			// 
			// tbEmail
			// 
			this.tbEmail.Enabled = false;
			this.tbEmail.Location = new System.Drawing.Point(64, 176);
			this.tbEmail.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(0, 176);
			this.label6.Size = new System.Drawing.Size(48, 20);
			this.label6.Text = "Email";
			// 
			// tbTelephone
			// 
			this.tbTelephone.Enabled = false;
			this.tbTelephone.Location = new System.Drawing.Point(64, 208);
			this.tbTelephone.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(0, 208);
			this.label7.Size = new System.Drawing.Size(60, 20);
			this.label7.Text = "Telephone";
			// 
			// tbPortable
			// 
			this.tbPortable.Enabled = false;
			this.tbPortable.Location = new System.Drawing.Point(64, 240);
			this.tbPortable.Text = "";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(0, 240);
			this.label8.Size = new System.Drawing.Size(60, 20);
			this.label8.Text = "Portable";
			// 
			// ActionsMenu
			// 
			this.ActionsMenu.MenuItems.Add(this.ItemModifier);
			this.ActionsMenu.Text = "Actions";
			// 
			// ItemModifier
			// 
			this.ItemModifier.Text = "Modifier";
			this.ItemModifier.Click += new System.EventHandler(this.ItemModifier_Click);
			// 
			// btImage
			// 
			this.btImage.Location = new System.Drawing.Point(168, 88);
			this.btImage.Size = new System.Drawing.Size(64, 24);
			this.btImage.Text = "Image";
			this.btImage.Visible = false;
			this.btImage.Click += new System.EventHandler(this.btImage_Click);
			// 
			// btRAZ
			// 
			this.btRAZ.Location = new System.Drawing.Point(168, 184);
			this.btRAZ.Size = new System.Drawing.Size(64, 24);
			this.btRAZ.Text = "R.A.Z";
			this.btRAZ.Visible = false;
			this.btRAZ.Click += new System.EventHandler(this.btRAZ_Click);
			// 
			// btRetour
			// 
			this.btRetour.Location = new System.Drawing.Point(168, 224);
			this.btRetour.Size = new System.Drawing.Size(64, 24);
			this.btRetour.Text = "Retour";
			this.btRetour.Click += new System.EventHandler(this.btRetour_Click);
			// 
			// btValider
			// 
			this.btValider.Location = new System.Drawing.Point(168, 144);
			this.btValider.Size = new System.Drawing.Size(64, 24);
			this.btValider.Text = "Valider";
			this.btValider.Visible = false;
			// 
			// Details
			// 
			this.Controls.Add(this.btImage);
			this.Controls.Add(this.btRAZ);
			this.Controls.Add(this.btRetour);
			this.Controls.Add(this.btValider);
			this.Controls.Add(this.tbPortable);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.tbTelephone);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.tbEmail);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.tbCp);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.tbVille);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.tbAdresse);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.tbPrenom);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.tbNom);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.pbImage);
			this.Menu = this.MenuApp;
			this.Text = "Details d\'un contact";
			this.Load += new System.EventHandler(this.Details_Load);

		}
		#endregion

		/// <summary>
		/// Fonction qui active les TextBox et les boutons servant  l'edition d'un contact
		/// </summary>
		private void EditContact()
		{
			// On parcours la liste des controls de la form
			foreach ( Control Ctrl in this.Controls )
			{
				// Si le control en cours est une TextBox
				//if ( Ctrl.GetType() == Type.GetType("System.Windows.Forms.TextBox") )
				if ( Ctrl.GetType().ToString() == "System.Windows.Forms.TextBox" )
				{
					// On permet sa modification (avec la proprit Enabled  True)
					Ctrl.Enabled = true;
				}
			}

			// Affichage des boutons cachs
			btImage.Visible = true;
			btValider.Visible = true;
			btRAZ.Visible = true;

			// Modification du titre de la fentre
			this.Text = "Edition d'un contact";

			ItemModifier.Checked = true;
		}

		/// <summary>
		/// Fonction qui dsactive les TextBox et les boutons servant  l'edition d'un contact
		/// </summary>
		private void UnEditContact()
		{
			// On parcours la liste des controls de la form
			foreach ( Control Ctrl in this.Controls )
			{
				// Si le control en cours est une TextBox
				//if ( Ctrl.GetType() == Type.GetType("System.Windows.Forms.TextBox") )
				if ( Ctrl.GetType().ToString() == "System.Windows.Forms.TextBox" )
				{
					// On interdit sa modification (avec la proprit Enabled  False)
					Ctrl.Enabled = false;
				}
			}

			// Dsaffichage des boutons cachs
			btImage.Visible = false;
			btValider.Visible = false;
			btRAZ.Visible = false;

			// Modification du titre de la fentre
			this.Text = "Dtails d'un contact";

			ItemModifier.Checked = false;
		}

		/// <summary>
		/// Fonction qui teste si la valeur passe en paramtre est une valeur NULL, auquel cas elle retourne une chane vide
		/// Sinon, elle retourne la valeur passe en paramtre
		/// </summary>
		/// <param name="value">Valeur  tester</param>
		/// <returns></returns>
		private string ReadString( object value ) 
		{ 
			if ( DBNull.Value.Equals( value ) ) 
			{
				return String.Empty; 
			}

			return Convert.ToString( value ); 
		}

		/// <summary>
		/// Chargement de la fentre
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Details_Load(object sender, System.EventArgs e)
		{
			try
			{
				Cursor.Current = Cursors.WaitCursor;

				// On dclare la chane de connexion  la base de donnes
				SqlCnx = new SqlCeConnection(@"Data Source = " + ContactsPPC.Liste.DATABASE_PATH);
				// On prpare la requte SQL  excuter : slection des champs  afficher
				sSQL = "SELECT * FROM Contacts WHERE Contact_Id = " + Contact_Id;

				SqlCommand = new SqlCeCommand(sSQL, SqlCnx);

				// On ouvre la connexion  la base de donnes
				SqlCnx.Open();

				daReader = SqlCommand.ExecuteReader();

				// Tant qu'il y a des donnes  lire
				while ( daReader.Read() )
				{
					// On remplit les textBox avec les valeurs
					tbNom.Text = ReadString(daReader["Contact_Nom"]);
					tbPrenom.Text = ReadString(daReader["Contact_Prenom"]);
					tbAdresse.Text = ReadString(daReader["Contact_Adresse"]);
					tbCp.Text = ReadString(daReader["Contact_Cp"]);
					tbVille.Text = ReadString(daReader["Contact_Ville"]);
					tbEmail.Text = ReadString(daReader["Contact_Email"]);
					tbTelephone.Text = ReadString(daReader["Contact_Telephone"]);
					tbPortable.Text = ReadString(daReader["Contact_Portable"]);

					// On rcupre, dans un tableau de byte, le contenu du champ Image de la base
					byte [] img = (byte []) daReader["Contact_Image"];
					// On cre une image,  partir de ce que l'on a rcupr, que l'on affecte  la proprit Image de notre objet pictureBox
					pbImage.Image = new Bitmap(new System.IO.MemoryStream(img));
				}

				// Fermeture de la connexion et du SqlCeDataReader
				if ( daReader != null )
				{
					daReader.Close();
				}
				if ( SqlCnx.State == ConnectionState.Open )
				{
					SqlCnx.Close();
				}
			}
			catch(SqlCeException Ex)
			{
				MessageBox.Show("Erreur SQL inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
			catch(Exception Ex)
			{
				MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
			finally
			{
				Cursor.Current = Cursors.Default;
			}
		}

		private void ItemQuitter_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void btRetour_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btRAZ_Click(object sender, System.EventArgs e)
		{
			// On parcours la liste des controls de la form
			foreach ( Control Ctrl in this.Controls )
			{
				// Si le control en cours est une TextBox
				//if ( Ctrl.GetType() == Type.GetType("System.Windows.Forms.TextBox") )
				if ( Ctrl.GetType().ToString() == "System.Windows.Forms.TextBox" )
				{
					// On remet  chaine vide
					Ctrl.Text = String.Empty;
				}
			}

			if ( pbImage.Image != null )
			{
				pbImage.Image = null;
			}
		}

		private void btImage_Click(object sender, System.EventArgs e)
		{
			// Paramtre de l'OpenFileDialog
			ChoixFichier.InitialDirectory = @"\My Documents";
			ChoixFichier.Filter = "Images|*.bmp;*.gif;*.jpg;*.jpeg;";

			// Si on clic sur Cancel
			if ( ChoixFichier.ShowDialog() == DialogResult.Cancel )
			{
				// On quitte sans rien faire
				return;
			}
			else // Sinon
			{
				// On rcupre l'image et on l'affecte  la pictureBox
				pbImage.Image = new Bitmap(ChoixFichier.FileName);
			}
		}

		// Clic sur le bouton Modifier et activation ou dsactivation des controles
		// pour l'dition du contact
		private void ItemModifier_Click(object sender, System.EventArgs e)
		{
			if ( !ItemModifier.Checked )
			{
				EditContact();
			}
			else
			{
				UnEditContact();
			}
		}
	}
}
