using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;

namespace ContactsPPC
{
	/// <summary>
	/// Description rsume de Liste.
	/// </summary>
	public class Liste : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu MenuApp;
		private System.Windows.Forms.MenuItem FileMenu;
		private System.Windows.Forms.MenuItem ItemQuitter;
		private System.Windows.Forms.ListView lvliste;
		private System.Windows.Forms.ColumnHeader Contact_Id;
		private System.Windows.Forms.ColumnHeader Contact_Nom;
		private System.Windows.Forms.ColumnHeader Contact_Prenom;
		private System.Windows.Forms.ColumnHeader Contact_Email;

		public const string DATABASE_PATH = @"\My Documents\contactsppc.sdf";
		private string sSQL = String.Empty;
		private SqlCeConnection SqlCnx;
		private SqlCeDataAdapter SqlDa = null;
		private SqlCeCommand SqlCommand = null;
		private System.Windows.Forms.MenuItem ItemDetails;
		private System.Windows.Forms.ContextMenu ContextMenuApp;
		private System.Windows.Forms.MenuItem ActionMenu;
		private System.Windows.Forms.MenuItem ItemModifier;
		private System.Windows.Forms.MenuItem RetourMenu;
		private System.Windows.Forms.MenuItem ItemEffacer;
		private System.Windows.Forms.MenuItem ItemModifierContext;
		private System.Windows.Forms.MenuItem ItemSupprimerContext;
		private System.Windows.Forms.MenuItem menuItem1;
		private DataSet ds = null;
	
		public Liste()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.MenuApp = new System.Windows.Forms.MainMenu();
			this.FileMenu = new System.Windows.Forms.MenuItem();
			this.ItemQuitter = new System.Windows.Forms.MenuItem();
			this.ActionMenu = new System.Windows.Forms.MenuItem();
			this.ItemModifier = new System.Windows.Forms.MenuItem();
			this.RetourMenu = new System.Windows.Forms.MenuItem();
			this.lvliste = new System.Windows.Forms.ListView();
			this.Contact_Id = new System.Windows.Forms.ColumnHeader();
			this.Contact_Nom = new System.Windows.Forms.ColumnHeader();
			this.Contact_Prenom = new System.Windows.Forms.ColumnHeader();
			this.Contact_Email = new System.Windows.Forms.ColumnHeader();
			this.ContextMenuApp = new System.Windows.Forms.ContextMenu();
			this.ItemDetails = new System.Windows.Forms.MenuItem();
			this.ItemEffacer = new System.Windows.Forms.MenuItem();
			this.ItemModifierContext = new System.Windows.Forms.MenuItem();
			this.ItemSupprimerContext = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			// 
			// MenuApp
			// 
			this.MenuApp.MenuItems.Add(this.FileMenu);
			this.MenuApp.MenuItems.Add(this.ActionMenu);
			this.MenuApp.MenuItems.Add(this.RetourMenu);
			// 
			// FileMenu
			// 
			this.FileMenu.MenuItems.Add(this.ItemQuitter);
			this.FileMenu.Text = "Fichier";
			this.FileMenu.Click += new System.EventHandler(this.FileMenu_Click);
			// 
			// ItemQuitter
			// 
			this.ItemQuitter.Text = "Quitter";
			this.ItemQuitter.Click += new System.EventHandler(this.ItemQuitter_Click);
			// 
			// ActionMenu
			// 
			this.ActionMenu.MenuItems.Add(this.menuItem1);
			this.ActionMenu.MenuItems.Add(this.ItemModifier);
			this.ActionMenu.MenuItems.Add(this.ItemEffacer);
			this.ActionMenu.Text = "Actions";
			// 
			// ItemModifier
			// 
			this.ItemModifier.Text = "Modifier";
			this.ItemModifier.Click += new System.EventHandler(this.ItemModifier_Click);
			// 
			// RetourMenu
			// 
			this.RetourMenu.Text = "Retour";
			this.RetourMenu.Click += new System.EventHandler(this.RetourMenu_Click);
			// 
			// lvliste
			// 
			this.lvliste.Columns.Add(this.Contact_Id);
			this.lvliste.Columns.Add(this.Contact_Nom);
			this.lvliste.Columns.Add(this.Contact_Prenom);
			this.lvliste.Columns.Add(this.Contact_Email);
			this.lvliste.ContextMenu = this.ContextMenuApp;
			this.lvliste.FullRowSelect = true;
			this.lvliste.Size = new System.Drawing.Size(240, 270);
			this.lvliste.View = System.Windows.Forms.View.Details;
			// 
			// Contact_Id
			// 
			this.Contact_Id.Text = "Id";
			this.Contact_Id.Width = 0;
			// 
			// Contact_Nom
			// 
			this.Contact_Nom.Text = "Nom";
			this.Contact_Nom.Width = 80;
			// 
			// Contact_Prenom
			// 
			this.Contact_Prenom.Text = "Prenom";
			this.Contact_Prenom.Width = 78;
			// 
			// Contact_Email
			// 
			this.Contact_Email.Text = "Email";
			this.Contact_Email.Width = 79;
			// 
			// ContextMenuApp
			// 
			this.ContextMenuApp.MenuItems.Add(this.ItemDetails);
			this.ContextMenuApp.MenuItems.Add(this.ItemModifierContext);
			this.ContextMenuApp.MenuItems.Add(this.ItemSupprimerContext);
			// 
			// ItemDetails
			// 
			this.ItemDetails.Text = "Dtails";
			this.ItemDetails.Click += new System.EventHandler(this.ItemDetails_Click);
			// 
			// ItemEffacer
			// 
			this.ItemEffacer.Text = "Effacer";
			this.ItemEffacer.Click += new System.EventHandler(this.ItemEffacer_Click);
			// 
			// ItemModifierContext
			// 
			this.ItemModifierContext.Text = "Modifier";
			this.ItemModifierContext.Click += new System.EventHandler(this.ItemModifier_Click);
			// 
			// ItemSupprimerContext
			// 
			this.ItemSupprimerContext.Text = "Effacer";
			this.ItemSupprimerContext.Click += new System.EventHandler(this.ItemEffacer_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Text = "Dtails";
			this.menuItem1.Click += new System.EventHandler(this.ItemDetails_Click);
			// 
			// Liste
			// 
			this.Controls.Add(this.lvliste);
			this.Menu = this.MenuApp;
			this.Text = "Liste des contacts";
			this.Load += new System.EventHandler(this.Liste_Load);

		}
		#endregion

		private void ItemQuitter_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void FileMenu_Click(object sender, System.EventArgs e)
		{
		
		}

		/// <summary>
		/// Chargement de la fentre
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Liste_Load(object sender, System.EventArgs e)
		{
			// u chargement de la fentre, on affiche la liste des contacts
			AfficheListeContacts();
		}

		/// <summary>
		/// Fonction servant  faire afficher la liste de tous les contacts dans la base
		/// </summary>
		private void AfficheListeContacts()
		{
			try
			{
				Cursor.Current = Cursors.WaitCursor;

				// Vidage de la listView
				lvliste.Items.Clear();

				// On dclare la chane de connexion  la base de donnes
				SqlCnx = new SqlCeConnection(@"Data Source = " + DATABASE_PATH);
				// On prpare la requte SQL  excuter
				sSQL = "SELECT * FROM Contacts ORDER BY Contact_Nom";
				SqlDa = new SqlCeDataAdapter(sSQL, SqlCnx);

				// On ouvre la connexion  la base de donnes
				SqlCnx.Open();

				// Instanciation et remplissage d'un DataSet (copie en mmoire de la table Contacts et de ses donnes)
				ds = new DataSet();
				SqlDa.FillSchema(ds, SchemaType.Source, "Contacts");
				SqlDa.Fill(ds, "Contacts");

				// Rcupration des donnes dans une table du DataSet
				DataTable TableContacts = ds.Tables["Contacts"];

				// On indique que l'on va commencer la mise  jour de la ListView
				lvliste.BeginUpdate();

				// Extraction des lignes (Rows) de la table du Dataset et 
				// Affichage de ses donnes dans la ListView
				ListViewItem objList = null;

				// On ajoute les lments un par un
				foreach (DataRow dr in TableContacts.Rows)
				{
					objList = new ListViewItem(new String[] { dr["Contact_Id"].ToString(), dr["Contact_Nom"].ToString(), dr["Contact_Prenom"].ToString(), dr["Contact_Email"].ToString() } );
					lvliste.Items.Add(objList);
					objList = null;
				}

				// On signale la fin de la mise  jour de la listeView
				lvliste.EndUpdate();

				// Si la connexion est ouverte, on la ferme.
				if ( SqlCnx.State == ConnectionState.Open )
				{
					SqlCnx.Close();
				}
			}
			catch(SqlCeException Ex)
			{
				MessageBox.Show("Erreur SQL inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
			catch(Exception Ex)
			{
				MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
			finally
			{
				Cursor.Current = Cursors.Default;
			}
		}

		/// <summary>
		/// Clic du menu contextuel pour afficher les dtails d'un contact
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ItemDetails_Click(object sender, System.EventArgs e)
		{
			// Si on a bien un contact de slectionn dans la listView
			if ( lvliste.FocusedItem != null )
			{
				// on affiche la fenetre de dtails de ce contact
				Details DetailContact = new Details(false, lvliste.FocusedItem.Text);
				DetailContact.Show();
			}
			else
			{
				MessageBox.Show("Erreur, vous devez slectionner un contact  visualiser/modifier", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
		}

		private void ItemModifier_Click(object sender, System.EventArgs e)
		{
			// Si on a bien un contact de slectionn dans la listView
			if ( lvliste.FocusedItem != null )
			{
				// on affiche la fenetre d'dition de ce contact
				Details DetailContact = new Details(true, lvliste.FocusedItem.Text);
				DetailContact.Show();
			}
			else
			{
				MessageBox.Show("Erreur, vous devez slectionner un contact  visualiser/modifier", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
		}

		private void RetourMenu_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		/// <summary>
		/// Effacement d'un contact
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ItemEffacer_Click(object sender, System.EventArgs e)
		{
			// Si on a bien un contact de slectionn dans la listView
			if ( lvliste.FocusedItem != null )
			{
				// On supprime le contact slectionn de la base
				try
				{
					SqlCnx = new SqlCeConnection(@"Data Source = " + DATABASE_PATH);
					// On prpare la requte SQL  excuter
					sSQL = "DELETE FROM Contacts WHERE Contact_Id = " + lvliste.FocusedItem.Text;
					SqlCommand = new SqlCeCommand(sSQL, SqlCnx);

					// On ouvre la connexion  la base de donnes
					SqlCnx.Open();

					// On execute la requte
					SqlCommand.ExecuteNonQuery();

					// Si la connexion est ouverte, on la ferme.
					if ( SqlCnx.State == ConnectionState.Open )
					{
						SqlCnx.Close();
					}

					MessageBox.Show("Contact supprim avec succs", "Suppression effectu", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);

					// On rafraichit la liste des contacts dans la listView
					AfficheListeContacts();
				}
				catch(SqlCeException Ex)
				{
					MessageBox.Show("Erreur SQL inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
				}
				catch(Exception Ex)
				{
					MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
				}
			}
			else
			{
				MessageBox.Show("Erreur, vous devez slectionner un contact  effacer", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
			}
		}
	}
}
