using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ContactsPPC
{
	/// <summary>
	/// Description rsume de ModifConfig.
	/// </summary>
	public class ModifConfig : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbpassword;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbLogin;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button btAnnuler;
		private System.Windows.Forms.TextBox tbServerWeb;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbSqlServer;
		private System.Windows.Forms.MainMenu MenuApp;
		private System.Windows.Forms.MenuItem MenuFichier;
		private System.Windows.Forms.MenuItem ItemQuitter;
		private System.Windows.Forms.Button btSave;
		private System.Windows.Forms.Label label1;
	
		public ModifConfig()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.tbpassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tbLogin = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.btAnnuler = new System.Windows.Forms.Button();
			this.btSave = new System.Windows.Forms.Button();
			this.tbServerWeb = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tbSqlServer = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.MenuApp = new System.Windows.Forms.MainMenu();
			this.MenuFichier = new System.Windows.Forms.MenuItem();
			this.ItemQuitter = new System.Windows.Forms.MenuItem();
			// 
			// tbpassword
			// 
			this.tbpassword.Location = new System.Drawing.Point(112, 152);
			this.tbpassword.PasswordChar = '*';
			this.tbpassword.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 152);
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.Text = "Pasword SQL:";
			// 
			// tbLogin
			// 
			this.tbLogin.Location = new System.Drawing.Point(112, 112);
			this.tbLogin.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 112);
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.Text = "Login SQL:";
			// 
			// btAnnuler
			// 
			this.btAnnuler.Location = new System.Drawing.Point(136, 192);
			this.btAnnuler.Size = new System.Drawing.Size(72, 24);
			this.btAnnuler.Text = "Retour";
			this.btAnnuler.Click += new System.EventHandler(this.btAnnuler_Click);
			// 
			// btSave
			// 
			this.btSave.Location = new System.Drawing.Point(40, 192);
			this.btSave.Size = new System.Drawing.Size(72, 24);
			this.btSave.Text = "Enregistrer";
			this.btSave.Click += new System.EventHandler(this.btSave_Click);
			// 
			// tbServerWeb
			// 
			this.tbServerWeb.Location = new System.Drawing.Point(112, 80);
			this.tbServerWeb.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 80);
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.Text = "Serveur HTTP:";
			// 
			// tbSqlServer
			// 
			this.tbSqlServer.Location = new System.Drawing.Point(112, 40);
			this.tbSqlServer.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 40);
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.Text = "Serveur SQL:";
			// 
			// MenuApp
			// 
			this.MenuApp.MenuItems.Add(this.MenuFichier);
			// 
			// MenuFichier
			// 
			this.MenuFichier.MenuItems.Add(this.ItemQuitter);
			this.MenuFichier.Text = "Fichier";
			// 
			// ItemQuitter
			// 
			this.ItemQuitter.Text = "Quitter";
			this.ItemQuitter.Click += new System.EventHandler(this.ItemQuitter_Click);
			// 
			// ModifConfig
			// 
			this.Controls.Add(this.tbpassword);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.tbLogin);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.btAnnuler);
			this.Controls.Add(this.btSave);
			this.Controls.Add(this.tbServerWeb);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.tbSqlServer);
			this.Controls.Add(this.label1);
			this.Menu = this.MenuApp;
			this.Text = "ModifConfig";

		}
		#endregion

		private void ItemQuitter_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void btAnnuler_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btSave_Click(object sender, System.EventArgs e)
		{
			// On demande  l'utilisateur s'il est sur de vouloir sauvegarder ces paramtres
			if ( MessageBox.Show("Etes-vous sur de vouloir sauvegarder ces paramtres dans le fichier de configuration ?", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes )
			{
				// Si oui, on sauvegarde la configuration.

				// Si le nom du serveur Web ou du serveur SQL ou du nom d'utilisateur SQL est vide, on indique une erreur
				if ( tbServerWeb.Text.Length < 0 )
				{
					MessageBox.Show("Erreur, le nom ou l'adresse du serveur Web doit tre renseign ", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					return;
				}
				else if ( tbSqlServer.Text.Length < 0 )
				{
					MessageBox.Show("Erreur, le nom ou l'adresse du serveur SQL doit tre renseign ", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					return;
				}
				else if ( tbLogin.Text.Length < 0 )
				{
					MessageBox.Show("Erreur, le login du serveur SQL doit tre renseign ", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					return;
				}
				else
				{
					try
					{
						// on ecrit la configuration
						ConfigReader cfgReader = new ConfigReader();

						cfgReader.SetXmlValue("WebServer", tbServerWeb.Text.Trim());
						cfgReader.SetXmlValue("SqlServer", tbSqlServer.Text.Trim());
						cfgReader.SetXmlValue("LoginSQL", tbLogin.Text.Trim());
						cfgReader.SetXmlValue("PasswordSQL", tbpassword.Text.Trim());

						MessageBox.Show("Ecriture du fichier de configuration effectue avec succs", "Envoi effectu", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					catch(Exception Ex)
					{
						MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
				}
			}
			else
			{
				// On ne fait rien
			}
		}
	}
}
