using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlServerCe;

namespace ContactsPPC
{
	/// <summary>
	/// Description rsume de Envoyer.
	/// </summary>
	public class Synchro : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbSqlServer;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btEnvoyer;
		private System.Windows.Forms.Button btAnnuler;
		private System.Windows.Forms.MainMenu MenuApp;
		private System.Windows.Forms.MenuItem FileMenu;
		private System.Windows.Forms.MenuItem ItemQuitter;
		private System.Windows.Forms.TextBox tbServerWeb;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbpassword;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbLogin;
		private System.Windows.Forms.Label label4;

		private bool bMode;
	
		public Synchro(bool bEnvoyer)
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			// Si bEnvoyer est  true, on est en mode Envoi des donnes
			// Sinon, on est en mod Rception des donnes.
			bMode = bEnvoyer;

			if ( bEnvoyer )
			{
				btEnvoyer.Text = "Envoyer";
				this.Text = "Envoi de donnes";
			}
			else
			{
				btEnvoyer.Text = "Recevoir";
				this.Text = "Rception de donnes";
			}
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.tbSqlServer = new System.Windows.Forms.TextBox();
			this.tbServerWeb = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.btEnvoyer = new System.Windows.Forms.Button();
			this.btAnnuler = new System.Windows.Forms.Button();
			this.MenuApp = new System.Windows.Forms.MainMenu();
			this.FileMenu = new System.Windows.Forms.MenuItem();
			this.ItemQuitter = new System.Windows.Forms.MenuItem();
			this.tbpassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tbLogin = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 40);
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.Text = "Serveur SQL:";
			// 
			// tbSqlServer
			// 
			this.tbSqlServer.Location = new System.Drawing.Point(112, 37);
			this.tbSqlServer.Text = "";
			// 
			// tbServerWeb
			// 
			this.tbServerWeb.Location = new System.Drawing.Point(112, 77);
			this.tbServerWeb.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 80);
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.Text = "Serveur HTTP:";
			// 
			// btEnvoyer
			// 
			this.btEnvoyer.Location = new System.Drawing.Point(48, 192);
			this.btEnvoyer.Size = new System.Drawing.Size(64, 24);
			this.btEnvoyer.Text = "Envoyer";
			this.btEnvoyer.Click += new System.EventHandler(this.btEnvoyer_Click);
			// 
			// btAnnuler
			// 
			this.btAnnuler.Location = new System.Drawing.Point(144, 192);
			this.btAnnuler.Size = new System.Drawing.Size(64, 24);
			this.btAnnuler.Text = "Retour";
			this.btAnnuler.Click += new System.EventHandler(this.btAnnuler_Click);
			// 
			// MenuApp
			// 
			this.MenuApp.MenuItems.Add(this.FileMenu);
			// 
			// FileMenu
			// 
			this.FileMenu.MenuItems.Add(this.ItemQuitter);
			this.FileMenu.Text = "Fichier";
			// 
			// ItemQuitter
			// 
			this.ItemQuitter.Text = "Quitter";
			this.ItemQuitter.Click += new System.EventHandler(this.ItemQuitter_Click);
			// 
			// tbpassword
			// 
			this.tbpassword.Location = new System.Drawing.Point(112, 152);
			this.tbpassword.PasswordChar = '*';
			this.tbpassword.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 152);
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.Text = "Pasword SQL:";
			// 
			// tbLogin
			// 
			this.tbLogin.Location = new System.Drawing.Point(112, 112);
			this.tbLogin.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 112);
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.Text = "Login SQL:";
			// 
			// Synchro
			// 
			this.Controls.Add(this.tbpassword);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.tbLogin);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.btAnnuler);
			this.Controls.Add(this.btEnvoyer);
			this.Controls.Add(this.tbServerWeb);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.tbSqlServer);
			this.Controls.Add(this.label1);
			this.Menu = this.MenuApp;
			this.Text = "Envoyer";
			this.Load += new System.EventHandler(this.Envoyer_Load);

		}
		#endregion

		private void btAnnuler_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void ItemQuitter_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		/// <summary>
		/// Chargement de la fentre. On extrait les information du fichier de configuration
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Envoyer_Load(object sender, System.EventArgs e)
		{
			// On charge les infos du fichier de config
			ConfigReader cfgReader = new ConfigReader();

			// On affecte les valeurs du fichier de config au TextBox
			tbSqlServer.Text = cfgReader.GetXmlValue("SqlServer");
			tbServerWeb.Text = cfgReader.GetXmlValue("WebServer");
			tbLogin.Text = cfgReader.GetXmlValue("LoginSQL");
			tbpassword.Text = cfgReader.GetXmlValue("PasswordSQL");
		}

		private void btEnvoyer_Click(object sender, System.EventArgs e)
		{
			SqlCeRemoteDataAccess Rda = null;

			string sConnexionLocale = @"Data Source=\My Documents\contactsppc.sdf";
			string sConnexionDistante = "Provider=sqloledb; Data Source=" + tbSqlServer.Text.Trim() + ";Initial Catalog=Contacts;User Id=" + tbLogin.Text.Trim() + ";Password=" + tbpassword.Text;

			// Si on est en mode Envoi des donnes
			if ( bMode )
			{
				// On demande si l'utilisateur est sur de vouloir envoyer les donnes
				if ( MessageBox.Show("Etes-vous sur de vouloir envoyer les donnes au serveur SQL ?", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes )
				{
					try
					{
						Rda = new SqlCeRemoteDataAccess();

						// Login et Mot de passe IIS pour se connecter  lagent SQL Server CE Serveur
						// Ici, on utilise l'accs Anonyme de SQL Server, donc chanes vides
						Rda.InternetLogin = String.Empty;
						Rda.InternetPassword = String.Empty;
						// Adresse de l'agent SQL Server CE
						Rda.InternetUrl = "http://" + tbServerWeb.Text.Trim() + "/sqlce/sscesa20.dll";
						// Chaine de connexion  la base de donnes locale
						Rda.LocalConnectionString = sConnexionLocale;

						// Envoi des donnes au serveur SQL.
						// La mthode Push prend 3 paramtres:
						// - le nom de la table  envoyer
						// - la chaine de connexion au serveur SQL
						// - une option de batching : indique si chacune des lignes doit tre transmise au sein dune transaction unitaire
						// ou si lensemble des lignes le sont au sein dune transaction unique.
						Rda.Push("Contacts", sConnexionDistante, RdaBatchOption.BatchingOn);

						MessageBox.Show("Envoi des donnes au serveur SQL effectu avec succs", "Envoi effectu", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					catch(SqlCeException Ex)
					{
						MessageBox.Show("Erreur SQL inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					catch(Exception Ex)
					{
						MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					finally
					{
						if ( Rda != null )
						{
							Rda.Dispose();
						}
					}
				}
				else
				{
					// On ne fait rien
				}
			}
			else
			{
				// On demande si l'utilisateur est sur de vouloir rcuprer les donnes
				if ( MessageBox.Show("Etes-vous sur de vouloir rapatrier les donnes du serveur SQL ?\nCeci supprimera les donnes que vous avez localement!", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes )
				{
					// Sinon, on est en mode Rception des donnes
					try
					{
						// On supprime la table locale, car la mthode Pull re-cre une table sur la base locale.
						// Donc, pour viter les erreurs, on supprime la table
						SqlCeConnection SqlCnx = null;

						// Ouverture de la connexion
						SqlCnx = new SqlCeConnection(sConnexionLocale);
						SqlCnx.Open();

						SqlCeCommand Cmd = SqlCnx.CreateCommand();

						// Suppression de la table
						Cmd.CommandText = "DROP TABLE Contacts";
						Cmd.ExecuteNonQuery();

						// Fermeture de la connexion
						if (SqlCnx.State != ConnectionState.Closed)
						{
							SqlCnx.Close();
						}

						Rda = new SqlCeRemoteDataAccess();

						// Login et Mot de passe IIS pour se connecter  lagent SQL Server CE Serveur
						// Ici, on utilise l'accs Anonyme de SQL Server, donc chanes vides
						Rda.InternetLogin = String.Empty;
						Rda.InternetPassword = String.Empty;
						// Adresse de l'agent SQL Server CE
						Rda.InternetUrl = "http://" + tbServerWeb.Text.Trim() + "/sqlce/sscesa20.dll";
						// Chaine de connexion  la base de donnes locale
						Rda.LocalConnectionString = sConnexionLocale;

						// Rception des donnes du serveur SQL
						// La mthode Pull prend 5 paramtres:
						// - le nom de la table  crer localement
						// - la requte permettant la rcupration des donnes depuis le serveur SQL
						// - la chaine de connexion au serveur SQL
						// - une option de suivi des modifications apports  SQLCE
						// - table de stockage des erreurs
						Rda.Pull("Contacts", "Select * from contacts", sConnexionDistante, RdaTrackOption.TrackingOnWithIndexes , "ErrorTable");

						MessageBox.Show("Rception des donnes depuis le serveur SQL effectue avec succs", "Rception effectue", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					catch(SqlCeException Ex)
					{
						MessageBox.Show("Erreur SQL inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					catch(Exception Ex)
					{
						MessageBox.Show("Erreur inattendue.\n" + Ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
					}
					finally
					{
						if ( Rda != null )
						{
							Rda.Dispose();
						}
					}
				}
				else
				{
					// On ne fait rien
				}
			}
		}
	}
}
