using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

namespace ContactsPPC
{
	/// <summary>
	/// Description rsume de Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MenuItem FileMenu;
		private System.Windows.Forms.MenuItem ItemQuitter;
		private System.Windows.Forms.Button btliste;
		private System.Windows.Forms.MainMenu MenuApp;
		private System.Windows.Forms.Button btsynchro;
		private System.Windows.Forms.Button btEnvoyer;
		private System.Windows.Forms.Button btRecevoir;
		private System.Windows.Forms.Button btajout;
		private System.Windows.Forms.MenuItem MenuOptions;
		private System.Windows.Forms.MenuItem ItemConfig;

		private bool bMode = false;

		public MainForm()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
		}
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.MenuApp = new System.Windows.Forms.MainMenu();
			this.FileMenu = new System.Windows.Forms.MenuItem();
			this.ItemQuitter = new System.Windows.Forms.MenuItem();
			this.MenuOptions = new System.Windows.Forms.MenuItem();
			this.ItemConfig = new System.Windows.Forms.MenuItem();
			this.btliste = new System.Windows.Forms.Button();
			this.btajout = new System.Windows.Forms.Button();
			this.btsynchro = new System.Windows.Forms.Button();
			this.btEnvoyer = new System.Windows.Forms.Button();
			this.btRecevoir = new System.Windows.Forms.Button();
			// 
			// MenuApp
			// 
			this.MenuApp.MenuItems.Add(this.FileMenu);
			this.MenuApp.MenuItems.Add(this.MenuOptions);
			// 
			// FileMenu
			// 
			this.FileMenu.MenuItems.Add(this.ItemQuitter);
			this.FileMenu.Text = "Fichier";
			// 
			// ItemQuitter
			// 
			this.ItemQuitter.Text = "Quitter";
			this.ItemQuitter.Click += new System.EventHandler(this.ItemQuitter_Click);
			// 
			// MenuOptions
			// 
			this.MenuOptions.MenuItems.Add(this.ItemConfig);
			this.MenuOptions.Text = "Options";
			// 
			// ItemConfig
			// 
			this.ItemConfig.Text = "Configuration";
			// 
			// btliste
			// 
			this.btliste.Location = new System.Drawing.Point(48, 88);
			this.btliste.Size = new System.Drawing.Size(144, 24);
			this.btliste.Text = "Liste des contacts";
			this.btliste.Click += new System.EventHandler(this.btliste_Click);
			// 
			// btajout
			// 
			this.btajout.Location = new System.Drawing.Point(48, 136);
			this.btajout.Size = new System.Drawing.Size(144, 24);
			this.btajout.Text = "Ajouter un contact";
			this.btajout.Click += new System.EventHandler(this.btajout_Click);
			// 
			// btsynchro
			// 
			this.btsynchro.Location = new System.Drawing.Point(48, 184);
			this.btsynchro.Size = new System.Drawing.Size(144, 24);
			this.btsynchro.Text = "Synchroniser serveur";
			this.btsynchro.Click += new System.EventHandler(this.btsynchro_Click);
			// 
			// btEnvoyer
			// 
			this.btEnvoyer.Location = new System.Drawing.Point(40, 224);
			this.btEnvoyer.Size = new System.Drawing.Size(72, 24);
			this.btEnvoyer.Text = "Envoyer";
			this.btEnvoyer.Visible = false;
			this.btEnvoyer.Click += new System.EventHandler(this.btEnvoyer_Click);
			// 
			// btRecevoir
			// 
			this.btRecevoir.Location = new System.Drawing.Point(128, 224);
			this.btRecevoir.Size = new System.Drawing.Size(72, 24);
			this.btRecevoir.Text = "Recevoir";
			this.btRecevoir.Visible = false;
			this.btRecevoir.Click += new System.EventHandler(this.btRecevoir_Click);
			// 
			// MainForm
			// 
			this.Controls.Add(this.btRecevoir);
			this.Controls.Add(this.btEnvoyer);
			this.Controls.Add(this.btsynchro);
			this.Controls.Add(this.btajout);
			this.Controls.Add(this.btliste);
			this.Menu = this.MenuApp;
			this.Text = "Gestionnaire de contacts";

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void ItemQuitter_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void btliste_Click(object sender, System.EventArgs e)
		{
			Liste ListeContact = new Liste();
			ListeContact.Show();
		}

		private void btajout_Click(object sender, System.EventArgs e)
		{
			Ajout AjouterContact = new Ajout();
			AjouterContact.Show();
		}

		private void btsynchro_Click(object sender, System.EventArgs e)
		{
			if ( !bMode )
			{
				btsynchro.Text = "Synchroniser serveur *";
				btEnvoyer.Visible = true;
				btRecevoir.Visible = true;

				bMode = true;
			}
			else
			{
				btsynchro.Text = "Synchroniser serveur";
				btEnvoyer.Visible = false;
				btRecevoir.Visible = false;

				bMode = false;
			}
		}

		private void btEnvoyer_Click(object sender, System.EventArgs e)
		{
			bool bEnvoyer = true;

			Synchro EnvoiData = new Synchro(bEnvoyer);
			EnvoiData.Show();
		}

		private void btRecevoir_Click(object sender, System.EventArgs e)
		{
			bool bEnvoyer = false;

			Synchro ReceptionData = new Synchro(bEnvoyer);
			ReceptionData.Show();
		}
	}
}
